/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT MODIFY */

/*
 * schema-defined QAPI visitor functions
 *
 * Copyright IBM, Corp. 2011
 *
 * Authors:
 *  Anthony Liguori   <aliguori@us.ibm.com>
 *
 * This work is licensed under the terms of the GNU LGPL, version 2.1 or later.
 * See the COPYING.LIB file in the top-level directory.
 *
 */

#include "rhev-qapi-visit.h"

void visit_type_NewImageMode(Visitor *m, NewImageMode * obj, const char *name, Error **errp)
{
    visit_type_enum(m, (int *)obj, NewImageMode_lookup, "NewImageMode", name, errp);
}

void visit_type_BlockdevSnapshot(Visitor *m, BlockdevSnapshot ** obj, const char *name, Error **errp)
{
    visit_start_struct(m, (void **)obj, "BlockdevSnapshot", name, sizeof(BlockdevSnapshot), errp);
    visit_type_str(m, (obj && *obj) ? &(*obj)->device : NULL, "device", errp);
    visit_type_str(m, (obj && *obj) ? &(*obj)->snapshot_file : NULL, "snapshot-file", errp);
    visit_start_optional(m, (obj && *obj) ? &(*obj)->has_format : NULL, "format", errp);
    if ((*obj)->has_format) {
        visit_type_str(m, (obj && *obj) ? &(*obj)->format : NULL, "format", errp);
    }
    visit_end_optional(m, errp);
    visit_start_optional(m, (obj && *obj) ? &(*obj)->has_mode : NULL, "mode", errp);
    if ((*obj)->has_mode) {
        visit_type_NewImageMode(m, (obj && *obj) ? &(*obj)->mode : NULL, "mode", errp);
    }
    visit_end_optional(m, errp);
    visit_end_struct(m, errp);
}

void visit_type_BlockdevSnapshotList(Visitor *m, BlockdevSnapshotList ** obj, const char *name, Error **errp)
{
    GenericList *i, **head = (GenericList **)obj;

    visit_start_list(m, name, errp);

    for (*head = i = visit_next_list(m, head, errp); i; i = visit_next_list(m, &i, errp)) {
        BlockdevSnapshotList *native_i = (BlockdevSnapshotList *)i;
        visit_type_BlockdevSnapshot(m, &native_i->value, NULL, errp);
    }

    visit_end_list(m, errp);
}

void visit_type_BlockdevMirror(Visitor *m, BlockdevMirror ** obj, const char *name, Error **errp)
{
    visit_start_struct(m, (void **)obj, "BlockdevMirror", name, sizeof(BlockdevMirror), errp);
    visit_type_str(m, (obj && *obj) ? &(*obj)->device : NULL, "device", errp);
    visit_type_str(m, (obj && *obj) ? &(*obj)->target : NULL, "target", errp);
    visit_start_optional(m, (obj && *obj) ? &(*obj)->has_format : NULL, "format", errp);
    if ((*obj)->has_format) {
        visit_type_str(m, (obj && *obj) ? &(*obj)->format : NULL, "format", errp);
    }
    visit_end_optional(m, errp);
    visit_start_optional(m, (obj && *obj) ? &(*obj)->has_speed : NULL, "speed", errp);
    if ((*obj)->has_speed) {
        visit_type_int(m, (obj && *obj) ? &(*obj)->speed : NULL, "speed", errp);
    }
    visit_end_optional(m, errp);
    visit_start_optional(m, (obj && *obj) ? &(*obj)->has_full : NULL, "full", errp);
    if ((*obj)->has_full) {
        visit_type_bool(m, (obj && *obj) ? &(*obj)->full : NULL, "full", errp);
    }
    visit_end_optional(m, errp);
    visit_start_optional(m, (obj && *obj) ? &(*obj)->has_mode : NULL, "mode", errp);
    if ((*obj)->has_mode) {
        visit_type_NewImageMode(m, (obj && *obj) ? &(*obj)->mode : NULL, "mode", errp);
    }
    visit_end_optional(m, errp);
    visit_end_struct(m, errp);
}

void visit_type_BlockdevMirrorList(Visitor *m, BlockdevMirrorList ** obj, const char *name, Error **errp)
{
    GenericList *i, **head = (GenericList **)obj;

    visit_start_list(m, name, errp);

    for (*head = i = visit_next_list(m, head, errp); i; i = visit_next_list(m, &i, errp)) {
        BlockdevMirrorList *native_i = (BlockdevMirrorList *)i;
        visit_type_BlockdevMirror(m, &native_i->value, NULL, errp);
    }

    visit_end_list(m, errp);
}

void visit_type_BlockdevActionKind(Visitor *m, BlockdevActionKind * obj, const char *name, Error **errp)
{
    visit_type_enum(m, (int *)obj, BlockdevActionKind_lookup, "BlockdevActionKind", name, errp);
}

void visit_type_BlockdevAction(Visitor *m, BlockdevAction ** obj, const char *name, Error **errp)
{
    Error *err = NULL;

    visit_start_struct(m, (void **)obj, "BlockdevAction", name, sizeof(BlockdevAction), &err);
    visit_type_BlockdevActionKind(m, &(*obj)->kind, "type", &err);
    if (err) {
        error_propagate(errp, err);
        goto end;
    }
    switch ((*obj)->kind) {
    case BLOCKDEV_ACTION_KIND_BLOCKDEV_SNAPSHOT_SYNC:
        visit_type_BlockdevSnapshot(m, &(*obj)->blockdev_snapshot_sync, "data", errp);
        break;
    case BLOCKDEV_ACTION_KIND___COM_REDHAT_DRIVE_MIRROR:
        visit_type_BlockdevMirror(m, &(*obj)->__com_redhat_drive_mirror, "data", errp);
        break;
    default:
        abort();
    }
end:
    visit_end_struct(m, errp);
}

void visit_type_BlockdevActionList(Visitor *m, BlockdevActionList ** obj, const char *name, Error **errp)
{
    GenericList *i, **head = (GenericList **)obj;

    visit_start_list(m, name, errp);

    for (*head = i = visit_next_list(m, head, errp); i; i = visit_next_list(m, &i, errp)) {
        BlockdevActionList *native_i = (BlockdevActionList *)i;
        visit_type_BlockdevAction(m, &native_i->value, NULL, errp);
    }

    visit_end_list(m, errp);
}

void visit_type_EventInfo(Visitor *m, EventInfo ** obj, const char *name, Error **errp)
{
    visit_start_struct(m, (void **)obj, "EventInfo", name, sizeof(EventInfo), errp);
    visit_type_str(m, (obj && *obj) ? &(*obj)->name : NULL, "name", errp);
    visit_end_struct(m, errp);
}

void visit_type_EventInfoList(Visitor *m, EventInfoList ** obj, const char *name, Error **errp)
{
    GenericList *i, **head = (GenericList **)obj;

    visit_start_list(m, name, errp);

    for (*head = i = visit_next_list(m, head, errp); i; i = visit_next_list(m, &i, errp)) {
        EventInfoList *native_i = (EventInfoList *)i;
        visit_type_EventInfo(m, &native_i->value, NULL, errp);
    }

    visit_end_list(m, errp);
}
